###############################
#### enaR to ODE functions ####
###############################

# setup ODE inputs               #NOTE: WILL WORK ON NETWORKS SMALLER THAN 999 NODES
ODEinputs=function(x){
  node.names = network.vertex.names(x)
  vertex=0
  U=unpack(x)
  for(i in 1:length(node.names)){
    if(nchar(i) == 1){
      vertex[i] = paste(c('X00',i), collapse='')
      assign(x=vertex[i], value=U$X[i])
    }
    if(nchar(i) == 2){
      vertex[i] = paste(c('X0',i), collapse='')
      assign(x=vertex[i], value=U$X[i])
    }
    if(nchar(i) == 3){
      vertex[i] = paste(c('X',i), collapse='')
      assign(x=vertex[i], value=U$X[i])
    }
  }
  state = unlist(mget(vertex))
  
  edge.names.row=rep(NA, (length(U$F)+length(U$z)+2*length(U$y)+length(U$X)))
  edge.names=rep(NA, (length(U$F)+length(U$z)+2*length(U$y)+length(U$X)))
  edge.vals=rep(NA, (length(U$F)+length(U$z)+2*length(U$y)+length(U$X)))
  row=0; col=0
  for(f in 1:length(U$F)){
    if(f%%nrow(U$F) != 0){
      row = f%%nrow(U$F)
    }else{
      row = nrow(U$F)
    }
    col=ceiling(f/ncol(U$F))
    
    if(nchar(row) == 1){
      edge.names.row[f] = paste(c('f00',row), collapse='')
      edge.vals[f]=U$F[f]
    }
    if(nchar(row) == 2){
      edge.names.row[f] = paste(c('f0',row), collapse='')
      edge.vals[f]=U$F[f]
    }
    if(nchar(row) == 3){
      edge.names.row[f] = paste(c('f',row), collapse='')
      edge.vals[f]=U$F[f]
    }
    
    if(nchar(col) == 1){
      edge.names[f] = paste(c(edge.names.row[f],'00',col), collapse='')
      edge.vals[f]=U$F[f]
    }
    if(nchar(col) == 2){
      edge.names[f] = paste(c(edge.names.row[f],'0',col), collapse='')
      edge.vals[f]=U$F[f]
    }
    if(nchar(col) == 3){
      edge.names[f] = paste(c(edge.names.row[f],col), collapse='')
      edge.vals[f]=U$F[f]
    }
    
  }
  for(z in (length(U$F)+1):(length(U$F)+length(U$z))){
    if(nchar((z-length(U$F))) == 1){
      edge.names[z] = paste(c('z00',z-length(U$F)), collapse='')
      edge.vals[z] = U$z[z-length(U$F)]
    }
    if(nchar((z-length(U$F))) == 2){
      edge.names[z] = paste(c('z0',z-length(U$F)), collapse='')
      edge.vals[z] = U$z[z-length(U$F)]
    }
    if(nchar((z-length(U$F))) == 3){
      edge.names[z] = paste(c('z',z-length(U$F)), collapse='')
      edge.vals[z] = U$z[z-length(U$F)]
    }
  }
  for(e in (length(U$F)+length(U$z)+1):(length(U$F)+length(U$z)+length(U$e))){
    if(nchar((e-length(U$F)-length(U$z))) == 1){
      edge.names[e] = paste(c('e00',(e-length(U$F)-length(U$z))), collapse='')
      edge.vals[e] = U$e[e-length(U$F)-length(U$z)]
    }
    if(nchar((e-length(U$F)-length(U$z))) == 2){
      edge.names[e] = paste(c('e0',(e-length(U$F)-length(U$z))), collapse='')
      edge.vals[e] = U$e[e-length(U$F)-length(U$z)]
    }
    if(nchar((e-length(U$F)-length(U$z))) == 3){
      edge.names[e] = paste(c('e',(e-length(U$F)-length(U$z))), collapse='')
      edge.vals[e] = U$e[e-length(U$F)-length(U$z)]
    }
  }
  for(r in (length(U$F)+length(U$z)+length(U$e)+1):(length(U$F)+length(U$z)+length(U$e)+length(U$r))){
    if(nchar((r-length(U$F)-length(U$z)-length(U$e))) == 1){
      edge.names[r] = paste(c('r00',(r-length(U$F)-length(U$z)-length(U$e))), collapse='')
      edge.vals[r] = U$r[r-length(U$F)-length(U$z)-length(U$e)]
    }
    if(nchar((r-length(U$F)-length(U$z)-length(U$e))) == 2){
      edge.names[r] = paste(c('r0',(r-length(U$F)-length(U$z)-length(U$e))), collapse='')
      edge.vals[r] = U$r[r-length(U$F)-length(U$z)-length(U$e)]
    }
    if(nchar((r-length(U$F)-length(U$z)-length(U$e))) == 3){
      edge.names[r] = paste(c('r',(r-length(U$F)-length(U$z)-length(U$e))), collapse='')
      edge.vals[r] = U$r[r-length(U$F)-length(U$z)-length(U$e)]
    }
  }
  for(x in (length(U$F)+length(U$z)+length(U$e)+length(U$r)+1):(length(U$F)+length(U$z)+length(U$e)+length(U$r)+length(U$X))){
    if(nchar((x-length(U$F)-length(U$z)-length(U$e)-length(U$r))) == 1){
      edge.names[x] = paste(c('storage00',(x-length(U$F)-length(U$z)-length(U$e)-length(U$r))), collapse='')
      edge.vals[x] = U$X[x-length(U$F)-length(U$z)-length(U$e)-length(U$r)]
    }
    if(nchar((x-length(U$F)-length(U$z)-length(U$e)-length(U$r))) == 2){
      edge.names[x] = paste(c('storage0',(x-length(U$F)-length(U$z)-length(U$e)-length(U$r))), collapse='')
      edge.vals[x] = U$X[x-length(U$F)-length(U$z)-length(U$e)-length(U$r)]
    }
    if(nchar((x-length(U$F)-length(U$z)-length(U$e)-length(U$r))) == 3){
      edge.names[x] = paste(c('storage',(x-length(U$F)-length(U$z)-length(U$e)-length(U$r))), collapse='')
      edge.vals[x] = U$X[x-length(U$F)-length(U$z)-length(U$e)-length(U$r)]
    }
  }
  for(i in 1:length(edge.names)){
    assign(x=edge.names[i], value=edge.vals[i])
  }
  parms = unlist(mget(edge.names))
  
  return(list(state=state, parms=parms, edge.names=edge.names, vertex.names=vertex))
}


#### create input function    #NOTE: WILL WORK ON NETWORKS OF 999 NODES AND SMALLER
getEQs=function(x, ODEin){
  U=unpack(x)
  EQ.list=list()
  for(e in 1:length(U$X)){
    node = ODEin$vertex.names[e]
    base = paste(c('d',ODEin$vertex.names[e],'.dt='), collapse='')
    
    z.in.index = which(substring(ODEin$edge.names,1) == paste(c("z",substr(node, start=2, stop=4)), collapse=''))
    f.in.index = which(substr(ODEin$edge.names, start=5, stop=7) == substr(node, start=2, stop=4))
    in.index=c(z.in.index, f.in.index)
    
    f.out.index = which(substr(ODEin$edge.names, start=2, stop=4) == substr(node, start=2, stop=4))
    out.index = f.out.index[-(length(f.out.index)-2)] #trim off z[e]
    
    inputs=rep(NA, (ncol(U$F)+1)) #+1 for z inputs
    outputs=rep(NA, (ncol(U$F)+2)) #+2 for exports and respirations
    donor=0
    
    for(i in 1:length(inputs)){
      if(i == 1){
        inputs[i]=paste(c(ODEin$edge.names[in.index[i]]), collapse='')
      }else{
        if(ODEin$parms[in.index[i]] == 0){
          inputs[i]=paste(c('+',ODEin$edge.names[in.index[i]],'*',0), collapse='')
        }else{
          donor=substr(ODEin$edge.names[in.index[i]], start=2, stop=4)
          store=which(substr(ODEin$edge.names, start=8, stop=10) == donor)
          inputs[i]=paste(c('+','(',ODEin$edge.names[in.index[i]],'/',ODEin$edge.names[store],')','*',ODEin$vertex.names[as.numeric(donor)]), collapse='')
        }
      }
    }
    for(i in 1:length(outputs)){
      if(i == length(outputs)){
        donor = substr(ODEin$edge.names[out.index[i]], start=2, stop=4)
        store=which(substr(ODEin$edge.names, start=8, stop=10) == donor)
        outputs[i]=paste(c('-','(',ODEin$edge.names[out.index[i]],'/',ODEin$edge.names[store],')','*',node), collapse='')
      }else{
        if(ODEin$parms[out.index[i]] == 0){
          outputs[i]=paste(c('-',ODEin$edge.names[out.index[i]],'*',0), collapse='')
        }else{
          donor = substr(ODEin$edge.names[out.index[i]], start=2, stop=4)
          store=which(substr(ODEin$edge.names, start=8, stop=10) == donor)
          outputs[i]=paste(c('-','(',ODEin$edge.names[out.index[i]],'/',ODEin$edge.names[store],')','*',node), collapse='')
        }
      }
    }
    EQ.list[[e]] = paste(c(base,inputs,outputs,';','\n','\n'), collapse='')
  }
  return(EQ.list)
}

# output for model function
fun.outputs=function(x){
  U=unpack(x)
  ODEin=ODEinputs(x)
  return.names=0
  for(e in 1:length(U$X)){
    return.names[e] = paste(c('d',ODEin$vertex.names[e],'.dt'), collapse='')
  }
  return.names = toString(return.names)
  return(return.names)
}

# generate model function
ena2ode = function(x){
  ODEin=ODEinputs(x)
  eqs=getEQs(x, ODEin)
  eqs=unlist(eqs)
  model.outputs=fun.outputs(x)
  fun=paste(c('function(times, state, parms){
                with(as.list(c(state,parms)),{\n',
            
            eqs,'\n',
            
            'list(c(',model.outputs,'))\n
              })\n
            }'), collapse='')

  #model=eval(parse(text=fun))
  return(fun)
}

# get network object from output, state, and parms of steady state ODE
odeBack2ena = function(out, parms, living=NULL){
  
  flow.index = which(substr(names(parms), start=1, stop=1) == 'f', arr.ind=TRUE)
  input.index = which(substr(names(parms), start=1, stop=1) == 'z', arr.ind=TRUE)
  exports.index = which(substr(names(parms), start=1, stop=1) == 'e', arr.ind=TRUE)
  respirations.index = which(substr(names(parms), start=1, stop=1) == 'r', arr.ind=TRUE)

  steady.state.flows = rep(NA, length(flow.index))
  steady.state.flow.matrix = matrix(0, nrow=(ncol(out)-1), ncol=(ncol(out)-1))
  steady.state.inputs = rep(NA, length(input.index))
  steady.state.exports = rep(NA, length(exports.index))
  steady.state.respirations = rep(NA, length(respirations.index))
  
  steady.state.storages = out[nrow(out),2:ncol(out)]
  
  for(i in 1:length(flow.index)){
    donor = as.numeric(substr(names(parms[flow.index[i]]), start=2, stop=4))
    recipient = as.numeric(substr(names(parms[flow.index[i]]), start=5, stop=7))
    state = which(substr(names(parms), start=8, stop=10) == substr(names(parms[flow.index[i]]), start=2, stop=4))
    steady.state.flows[i] = (parms[flow.index[i]]/parms[state])*steady.state.storages[donor]
    steady.state.flow.matrix[donor,recipient] = steady.state.flows[i]
  }
  
  for(i in 1:length(input.index)){
    steady.state.inputs[i] = parms[input.index[i]]
  }
  
  for(i in 1:length(exports.index)){
    donor = as.numeric(substr(names(parms[exports.index[i]]), start=2, stop=4))
    state = which(substr(names(parms), start=8, stop=10) == substr(names(parms[exports.index[i]]), start=2, stop=4))
    steady.state.exports[i] = (parms[exports.index[i]]/parms[state])*steady.state.storages[donor]
  }
  for(i in 1:length(respirations.index)){
    donor = as.numeric(substr(names(parms[respirations.index[i]]), start=2, stop=4))
    state = which(substr(names(parms), start=8, stop=10) == substr(names(parms[respirations.index[i]]), start=2, stop=4))
    steady.state.respirations[i] = (parms[respirations.index[i]]/parms[state])*steady.state.storages[donor]
  }
  
  if(is.null(living)){
    steady.state.living=rep(FALSE, (ncol(out)-1))
  }else{
    steady.state.living=living
  }
  
  # calcluate y = e + r
  steady.state.outputs = steady.state.exports + steady.state.respirations
  
  network = pack(flow =  steady.state.flow.matrix, 
                 input = steady.state.inputs, 
                 output = steady.state.outputs, 
                 storage = steady.state.storages, 
                 living = steady.state.living, 
                 respiration = steady.state.respirations, 
                 export = steady.state.exports)
  
  return(network)
}


#Extract rate constants from network
getRates = function(x){
  ODEin = ODEinputs(x)
  f.index = which(substr(ODEin$edge.names, start=1, stop=1) == "f")
  #z.index = which(substr(ODEin$edge.names, start=1, stop=1) == "z") #not donor controlled
  e.index = which(substr(ODEin$edge.names, start=1, stop=1) == "e")
  r.index = which(substr(ODEin$edge.names, start=1, stop=1) == "r")
  
  rate.constants = c()
  donor.index=c()
  pos=1
  for(i in 1:length(f.index)){
    if(ODEin$parms[f.index[i]] != 0){
      donor.index = which(substr(names(ODEin$parms), start=8, stop=10) == substr(names(ODEin$parms[f.index[i]]), start=2, stop=4))
      rate.constants[pos] = ODEin$parms[f.index[i]] / ODEin$parms[donor.index]
      pos = pos+1
    }else{
    pos=pos
    }
  }
  for(i in 1:length(e.index)){
    if(ODEin$parms[e.index[i]] != 0){
      donor.index = which(substr(names(ODEin$parms), start=8, stop=10) == substr(names(ODEin$parms[e.index[i]]), start=2, stop=4))
      rate.constants[pos] = ODEin$parms[e.index[i]] / ODEin$parms[donor.index]
      pos = pos+1
    }else{
    pos=pos
    }
  }
  for(i in 1:length(r.index)){
    if(ODEin$parms[r.index[i]] != 0){
      donor.index = which(substr(names(ODEin$parms), start=8, stop=10) == substr(names(ODEin$parms[r.index[i]]), start=2, stop=4))
      rate.constants[pos] = ODEin$parms[r.index[i]] / ODEin$parms[donor.index]
      pos = pos+1
    }else{
    pos=pos
    }
  }
  names(rate.constants) = names(c(ODEin$parms[f.index[which(ODEin$parms[f.index] != 0)]], 
                                  ODEin$parms[e.index[which(ODEin$parms[e.index] != 0)]], 
                                  ODEin$parms[r.index[which(ODEin$parms[r.index] != 0)]]))
 return(rate.constants)
}

################## ODE UA

#function to generate log-normal samples between two points
parm.range=function(min, max, n, q=0.99999){
  mean = mean(log(c(min,max)))
  SD = (log(max) - mean) / qnorm(q)
  
  #values = rlnorm(n, meanlog=mean, sdlog=SD)
  values = runif(n, min=min, max=max)
  return(values)
}

#function to generate log-normal samples between two points
log.parm.finder=function(min, max, q=0.99999){
  m = mean(c(min,max))
  s = ((max-min)/3)/2
  location <- log(m^2 / sqrt(s^2 + m^2))
  shape <- sqrt(log(1 + (s^2 / m^2)))
  
  return(c(location,shape))
}

#generate new parmaters set assuming +/- % error on each flow
parms.mod = function(parms, p.err){
  exclude = which(substr(names(parms), start=8, stop=10) != "")
  for(i in 1:(length(parms)-length(exclude))){
    if(parms[i] != 0){
      
      min = parms[i]-((p.err/100)*parms[i])
      max = parms[i]+((p.err/100)*parms[i])
      
      new.val = parm.range(min=min, max=max, n=1)
      
      parms[i] = new.val
      
    } else {
      parms[i] = parms[i]
    }
  }
  return(parms)
}

#conduct ODE uncertainty analysis
ode.UA = function(M, n, p.err, ODEtimes){
  ODEin = ODEinputs(M)
  
  #generate function for mass-balance equations
  func=ena2ode(x=M) #stores function as a text string
  model=eval(parse(text = func)) #creates a function for use in ode()
  
  network=list()
  for(k in 1:n){
    parms.new = parms.mod(parms=ODEin$parms, p.err=p.err)
    out.mod=ode(y=ODEin$state, times=ODEtimes, func=model, parms=parms.new)
    
    #extract network
    network[[k]] = odeBack2ena(out=out.mod, parms=parms.new)
    print(paste('ODE run =',k))
  }
  return(network)
}

